import addonHandler
addonHandler.initTranslation()
import appModuleHandler
from logHandler import log
debug = log.warning
import time
import scriptHandler
import api
import os
import wx
import ui
import eventHandler
import string
import textInfos
import sayAllHandler
import controlTypes
import speech
import itertools
import virtualBuffers
import braille
from NVDAObjects.window.winword import WordDocument, wdParagraph, wdSentence,wdActiveEndPageNumber , wdFirstCharacterLineNumber ,WordDocumentTextInfo
from wordPack.ww_wdConst import wdHorizontalPositionRelativeToPage , wdVerticalPositionRelativeToPage ,wdFirstCharacterColumnNumber 
import wordPack
import wordPack.ww_config
import wordPack.ww_tables
import wordPack.ww_comments
import wordPack.ww_headings
import wordPack.ww_utils 
from wordPack.ww_utils  import printDebug, maximizeWindow
from wordPack.ww_msg import NVDAString
from wordPack.ww_comments import Comments
from wordPack.ww_revisions import Revisions
import config
from keyboardHandler import KeyboardInputGesture
import inputCore
from globalCommands import GlobalCommands, commands
from wordPack.ww_browseMode import *
import treeInterceptorHandler
import browseMode

_addonDir = os.path.join(os.path.dirname(__file__), "..").decode("mbcs") # The root of an addon folder
_curAddon = addonHandler.Addon(_addonDir) # Addon instance
_addonSummary = _curAddon.manifest['summary']
_scriptCategory = unicode(_addonSummary)
_quickNavigationScriptCategory = inputCore.SCRCAT_BROWSEMODE
# global timer
GB_taskTimer= None
GB_scriptTimer = None
# delay for waiting new script call
_delay = 250
	



def stopScriptTimer():
	global GB_scriptTimer
	if GB_scriptTimer != None:
		GB_scriptTimer.Stop()
		GB_scriptTimer = None

class WordDocumentEx(WordDocument):
	treeInterceptorClass=WordDocumentTreeInterceptorEx

	_gestures = {
		"kb:nvda+alt+f5": "makeChoice",
		"kb:alt+numpaddelete": "report_location",
		"kb(laptop):alt+delete": "report_location",
		"kb:Shift+Alt+leftArrow" : "report_headingLevel",
		"kb:Shift+Alt+rightArrow" : "report_headingLevel",
		# tables
		"kb:NVDA+shift+h":"reportCurrentHeaders",
		"kb:windows+Alt+;": "report_currentRow",
		"kb:windows+Alt+," : "report_currentColumn",
		"kb:windows+Alt+rightArrow": "moveToNextColumn",
		"kb:windows+Alt+leftArrow" : "moveToPreviousColumn",
		"kb:windows+Alt+downArrow" : "moveToNextRow",
		"kb:windows+Alt+upArrow": "moveToPreviousRow",
		"kb:windows+alt+home" : "moveToStartOfRow",
		"kb:windows+alt+end" : "moveToEndOfRow",
		"kb:windows+alt+pageUp" : "moveToStartOfColumn",
		"kb:windows+alt+pageDown" : "moveToEndOfColumn",
		# report element text
		"kb:nvda+alt+n": "reportCurrentEndNoteOrFootNote",
		"kb:nvda+alt+r": "reportCurrentRevision",
		"kb:nvda+alt+c": "reportCurrentComment",
		# move sentence by sentence
		"kb:alt+downArrow" : "nextSentence",
		"kb:alt+upArrow" : "previousSentence",
		"kb:nvda+shift+alt+c" : "insertComment",
		#"kb:NVDA+shift+c":"setColumnHeader",
		#"kb:NVDA+shift+r":"setRowHeader",
		}
		

		
	def initOverlayClass(self):
		printDebug ("WordDocumentEx InitOverlayClass")
		for gesture in self._gestures.keys():
			self.bindGesture(gesture, self._gestures[gesture])
	def __init__(self,*args,**kwargs):
		super(WordDocumentEx,self).__init__(*args,**kwargs)
		
	def inTable(self, withMessage = False):
		doc = self.WinwordDocumentObject
		selection = self.WinwordSelectionObject
		selection.Collapse()
		r = doc.range (selection.Start, selection.End)
		inTable = False
		try:
			if r.Tables.Count == 1 and r.Cells.Count == 1:
				inTable = True
		except:
			pass
		
		if not inTable and withMessage:
			# Translators: The message reported when a user attempts to use a table movement command
			# when the cursor is not withnin a table.
			ui.message(_("Not in table"))
			
		return inTable
	
	def script_insertComment(self,gesture):
		printDebug ("insert comment")
		stopScriptTimer()
		winwordApplication = self._get_WinwordApplicationObject()
		if winwordApplication :
			wx.CallAfter(wordPack.ww_comments.insertComment, winwordApplication)
		else:
			log.warning(" No winword application")

		
	# Translators: a description for a script
	script_insertComment.__doc__ =_("Insert a comment where the System caret is located.")
	script_insertComment.category = _scriptCategory
	
		
	def script_reportCurrentComment(self,gesture):
		printDebug ("report current comment")
		stopScriptTimer()
		self.reportCurrentElement( Comments)

	script_reportCurrentComment.__doc__=NVDAString("Reports the text of the comment where the System caret is located.") 
	script_reportCurrentComment.category = _scriptCategory
	def reportCurrentElement(self, elementClass):
		col = elementClass(None,self, "focus")
		col.reportElements()


	def script_reportCurrentEndNoteOrFootNote(self, gesture):
		info=self.makeTextInfo(textInfos.POSITION_CARET)
		info.expand(textInfos.UNIT_CHARACTER)
		fields=info.getTextWithFields(formatConfig={'reportComments':True})		
		for field in reversed(fields):
			if not(isinstance(field,textInfos.FieldCommand) and isinstance(field.field,textInfos.ControlField)): 
				continue
				
			role=field.field.get('role')
			start = self.WinwordDocumentObject.content.start
			end = self.WinwordDocumentObject.content.end
			range=self.WinwordDocumentObject.range(start,end)
			if role == controlTypes.ROLE_FOOTNOTE:
				val =field.field.get('value')
				try:
					col = range.footNotes
					text=col[int(val)].range.text
					if text == None or len(text) == 0:
						text = _("empty")
					ui.message(text)
					return
				except :
					break
			if role == controlTypes.ROLE_ENDNOTE:
				val =field.field.get('value')
				try:
					text=range.EndNotes[int(val)].range.text
					if text == None or len(text) == 0:
						text = _("empty")

					ui.message(text)
					return
				except :
					printDebug ("endnotes")
					break

				


				return
				# Translators: a message when there is no endnoe or footnote to report in Microsoft Word
		ui.message(_("no endnote or footnote"))

	script_reportCurrentEndNoteOrFootNote.__doc__=_("Reports the text of the endnote or footnote where the System caret is located.") 
	script_reportCurrentEndNoteOrFootNote.category = _scriptCategory
	
	

	def script_reportCurrentRevision(self, gesture):
		wx.CallAfter(self.reportCurrentElement, Revisions)

		
	script_reportCurrentRevision.__doc__=_("Reports the text of the revision where the System caret is located.")
	script_reportCurrentRevision.category = _scriptCategory	
	
	
	def _getPageAndLineNumber(self):
		(start, end) = (self.WinwordSelectionObject.Start, self.WinwordSelectionObject.End)
		r = self.WinwordDocumentObject.range (start, start)
		if self.inTable():
			return None

		line = r.information(wdFirstCharacterLineNumber )
		page = r.Information(wdActiveEndPageNumber )
		return (page, line)
	def _moveToNextOrPriorElement(self,direction , type ="paragraph"):
		res = self._getPageAndLineNumber()
		if not res:
			# no document or not in text
			return

		if res == (1,1) and direction == -1:
			# top of document
			return
		if type == "paragraph":
			unit = textInfos.UNIT_PARAGRAPH
			wdUnit = wdParagraph
		else:
			unit = textInfos.UNIT_SENTENCE
			wdUnit = wdSentence
		
		info=self.makeTextInfo(textInfos.POSITION_CARET)
		if not info:
			return
		
		# #4375: keeping cemetrical with nextParagraph script. 
		info._rangeObj.move(wdUnit,direction)
		info.updateCaret()
		if type != "paragraph":
			return
			
		# we skip a maximum  of empty paragraph
		i= 100
		flag = wordPack.ww_config.toggleSkipEmptyParagraphsOption(False)
		while flag and i:
			i = i -1
			res = self._getPageAndLineNumber()
			if not res:
				return
			

			if res == (1,1):
				return
			try:
				info=self.makeTextInfo(textInfos.POSITION_CARET)
			except:
				return
			
			info.expand(unit)
			text = string.strip(info.text)
			info.collapse()
			if len(text) != 0:
				return
			
			info._rangeObj.move(wdUnit,direction)
			info.updateCaret()
		
	def script_nextSentence(self,gesture):
		self._moveToNextOrPriorElement(1, "sentence")
		self._caretScriptPostMovedHelper(textInfos.UNIT_SENTENCE,gesture,None)
	
	def script_previousSentence(self,gesture):
		self._moveToNextOrPriorElement(-1, "sentence")
		self._caretScriptPostMovedHelper(textInfos.UNIT_SENTENCE,gesture,None)	
		
	script_previousSentence.__doc__ = _("Move to the previous sentence")
	script_previousSentence.category = _scriptCategory
	script_previousSentence.resumeSayAllMode=sayAllHandler.CURSOR_CARET
	script_nextSentence.__doc__ = _("Move to the next sentence")
	script_nextSentence.category = _scriptCategory
	script_nextSentence.resumeSayAllMode=sayAllHandler.CURSOR_CARET	
	
	def script_nextParagraph(self,gesture):
		self._moveToNextOrPriorElement(1, "paragraph")
		self._caretScriptPostMovedHelper(textInfos.UNIT_PARAGRAPH,gesture,None)
	
	def script_previousParagraph(self,gesture):
		self._moveToNextOrPriorElement(-1, "paragraph")
		self._caretScriptPostMovedHelper(textInfos.UNIT_PARAGRAPH,gesture,None)

	script_previousParagraph.resumeSayAllMode=sayAllHandler.CURSOR_CARET
	script_previousParagraph.__doc__ = _("Move to the previous paragraph( skip empty paragraphs if SkipEmptyParagraph flag is set to on) ")
	script_previousParagraph.category = _scriptCategory
	script_nextParagraph.resumeSayAllMode=sayAllHandler.CURSOR_CARET
	script_nextParagraph.__doc__ = _("Move to the next paragraph( skip empty paragraphs if SkipEmptyParagraph flag is set to on) ")
	script_nextParagraph.category = _scriptCategory
	
	def script_makeChoice(self, gesture, ):
		printDebug ("script_makeChoice")
		wx.CallAfter(wordPack.ChoiceDialog.run, self)
	
	script_makeChoice.category = _scriptCategory
	script_makeChoice.__doc__ = _("Display a dialog  to get word object informations in a range")
	
	def script_report_location(self, gesture):
		doc = self.WinwordDocumentObject
		(start, end) = (self.WinwordSelectionObject.Start, self.WinwordSelectionObject.End)
		r = doc.range (start, start)
		left= self.getLocalizedMeasurementTextForPointSize (r.information(wdHorizontalPositionRelativeToPage))
		top=self.getLocalizedMeasurementTextForPointSize( r.information(wdVerticalPositionRelativeToPage))
		position = _("at {0} from left edge and {1} from top edge of the page").format(left, top)
		if start == end:
			if self.inTable():
				cell = r.Cells[0]
				(row, col) = (cell.rowIndex, cell.columnIndex)
				location = _("You are at the row {row}, column {column}  of table") .format(row = row, column = col)
				ui.message("%s, %s." %(location, position))
				return

			line = r.information(wdFirstCharacterLineNumber )
			column = r.information(wdFirstCharacterColumnNumber )
			page = r.Information(wdActiveEndPageNumber )

			location = _("you are at Line {line}, column {column} of page {page}") .format(line = line, column = column, page= page)
			ui.message("%s, %s." %(location, position))
		else:
			line = r.information(wdFirstCharacterLineNumber )
			column = r.information(wdFirstCharacterColumnNumber )
			page = r.Information(wdActiveEndPageNumber )
			location = _("Selection begins at line {line}, column {column} of page {page}").format(line =line, column = column, page= page)
			ui.message("%s, %s." %(location, position))
			r = doc.range (end-1, end)
			line = r.information(wdFirstCharacterLineNumber )
			column = r.information(wdFirstCharacterColumnNumber )
			page = r.Information(wdActiveEndPageNumber )
			left= self.getLocalizedMeasurementTextForPointSize (r.information(wdHorizontalPositionRelativeToPage))
			top=self.getLocalizedMeasurementTextForPointSize( r.information(wdVerticalPositionRelativeToPage))
			position = _("at {0} from left edge and {1} from top edge of the page.").format(left, top)
			location = _("It ends at line {line}, column {column} of page {page}").format(line = line, column = column, page= page)
			ui.message("%s, %s" %(location, position))



			

	script_report_location.category = _scriptCategory
	script_report_location.__doc__ = _("Report the  page number and line number relative to the page")
	script_report_location.category = _scriptCategory
	
	def script_report_headingLevel(self, gesture):
		gesture.send()
		wx.CallAfter(wordPack.ww_headings.reportHeadingLevel, self)
	
	def _reportTableElement(self, type = "row", whichOne = "current", moveToFirst = False, withFirst = False):
		stopScriptTimer()
		if not self.inTable(True):
			return
		
		self.doc = self.WinwordDocumentObject
		(start, end) = (self.WinwordSelectionObject.Start, self.WinwordSelectionObject.End)
		r = self.doc.range (start, start)
		cell = wordPack.ww_tables.Cell(self, r.Cells[0])
		table = wordPack.ww_tables.Table(self, r.Tables[0])
		if moveToFirst:
			text = ""
			if  type == "cell" and whichOne== "firstInRow":
				cell = table.moveToCell("row", "first", cell)
				text= _("Start of row {0}") .format(cell.rowIndex) if cell != None else ""
				if  cell != None and cell.columnIndex !=1:
					text = text + _(" column {0}").format(cell.columnIndex)
			elif  type == "cell" and whichOne== "lastInRow":
				cell = table.moveToCell("row", "last", cell)
				text= _("End of row {0}") .format(cell.rowIndex) if cell != None else ""
			elif type == "cell" and whichOne == "firstInColumn":
				cell = table.moveToCell("column", "first", cell)
				text = _("Start of column {0}") .format( cell.columnIndex) if cell != None else ""
				if cell != None and cell.rowIndex != 1:
					text =  text + _(" line {0}").format(cell.rowIndex)

			elif type == "cell" and whichOne == "lastInColumn":
				cell = table.moveToCell("column", "last", cell)
				text = _("End of column {0}") .format(cell.columnIndex) if cell != None else ""
			elif type == "row" :
				cell = table.moveToCell("column", whichOne, cell)
			elif  type == "column":
				cell = table.moveToCell("row", whichOne, cell)
			else:
				cell = table.moveToCell(type, whichOne, cell)
				

			if cell == None:
				return
			if text != "":
				ui.message(text)
			whichOne = "current"

		table.sayElement( type, whichOne, cell,withFirst)

		info=self.makeTextInfo(textInfos.POSITION_CARET)
		#info.expand(textInfos.UNIT_CHARACTER)
		#speech.speakTextInfo(info,reason=controlTypes.REASON_CARET)
		#info.collapse()
		info.updateCaret()

	def script_report_currentRow(self, gesture):
		stopScriptTimer()
		type = "row"
		whichOne = "current"
		moveToFirst = False
		withFirst = scriptHandler.getLastScriptRepeatCount()>0
		if withFirst:
			wx.CallAfter(self._reportTableElement,type, whichOne, moveToFirst, withFirst)
		else:
			GB_taskTimer = wx.CallLater(_delay, self._reportTableElement,type, whichOne, moveToFirst, withFirst)

	script_report_currentRow.__doc__ = _("Say the current table' row")
	script_report_currentRow.category = _scriptCategory
	
	
	def script_report_currentColumn(self, gesture):
		stopScriptTimer()
		type = "column"
		whichOne = "current"
		moveToFirst = False
		withFirst = scriptHandler.getLastScriptRepeatCount()>0
		if withFirst:
			wx.CallAfter(self._reportTableElement,type, whichOne, moveToFirst, withFirst)
		else:
			GB_taskTimer = wx.CallLater(_delay, self._reportTableElement,type, whichOne, moveToFirst, withFirst)
		
	script_report_currentColumn.__doc__ = _("Say the current table column")
	script_report_currentColumn.category = _scriptCategory
	
	def script_moveToNextRow(self,gesture):
		stopScriptTimer()
		type = "row"
		whichOne = "next"
		moveToFirst = True
		withFirst =scriptHandler.getLastScriptRepeatCount() > 0
		if withFirst:
			wx.CallAfter(self._reportTableElement, type, whichOne, moveToFirst, withFirst)
		else:
			GB_taskTimer = wx.CallLater(_delay, self._reportTableElement,type, whichOne, moveToFirst, withFirst)
		
		
	script_moveToNextRow.__doc__ = _("Move to and say next row")
	script_moveToNextRow.category = _scriptCategory
	
	def script_moveToPreviousRow(self,gesture):
		stopScriptTimer()
		type = "row"
		whichOne = "previous"
		moveToFirst = True
		withFirst = scriptHandler.getLastScriptRepeatCount() >0
		if withFirst:
			wx.CallAfter(self._reportTableElement, type, whichOne, moveToFirst, withFirst)
		else:
			GB_taskTimer = wx.CallLater(_delay, self._reportTableElement,type, whichOne, moveToFirst, withFirst)
	
	script_moveToPreviousRow.__doc__ = _("Move to and say prior row")
	script_moveToPreviousRow.category = _scriptCategory
	
	def script_moveToNextColumn(self,gesture):
		stopScriptTimer()
		type = "column"
		whichOne = "next"
		moveToFirst = True
		withFirst =  scriptHandler.getLastScriptRepeatCount()>0
		if withFirst:
			wx.CallAfter(self._reportTableElement, type, whichOne, moveToFirst, withFirst)
		else:
			GB_taskTimer = wx.CallLater(_delay, self._reportTableElement,type, whichOne,moveToFirst, withFirst)
		
	script_moveToNextColumn.__doc__ = _("Move to and say next column")
	script_moveToNextColumn.category = _scriptCategory
	def script_moveToPreviousColumn(self,gesture):
		stopScriptTimer()
		type = "column"
		whichOne = "previous"
		moveToFirst = True
		withFirst = scriptHandler.getLastScriptRepeatCount() >0
		if withFirst:
			wx.CallAfter(self._reportTableElement, type, whichOne, moveToFirst, withFirst)
		else:
			GB_taskTimer = wx.CallLater(_delay, self._reportTableElement,type, whichOne, moveToFirst, withFirst)
	
	script_moveToPreviousColumn.__doc__ = _("Move to  and say prior column ")
	script_moveToPreviousColumn.category = _scriptCategory


	def script_moveToStartOfColumn(self, gesture):
		stopScriptTimer()

		whichOne = "firstInColumn"
		withFirst = False
		moveToFirst = scriptHandler.getLastScriptRepeatCount() >0
		if withFirst:
			wx.CallAfter(self._reportTableElement, type, whichOne, moveToFirst, withFirst)
		else:
			GB_taskTimer = wx.CallLater(_delay, self._reportTableElement, "cell", whichOne, moveToFirst,withFirst)



	script_moveToStartOfColumn.__doc__ = _("Say the first cell of the  column. Twice, move to and say it.")
	script_moveToStartOfColumn.category = _scriptCategory
	
	
	def script_moveToEndOfColumn (self, gesture):
		stopScriptTimer()
		whichOne = "lastInColumn"
		withFirst = False
		moveToFirst = scriptHandler.getLastScriptRepeatCount() >0
		if withFirst:
			wx.CallAfter(self._reportTableElement, type, whichOne, moveToFirst, withFirst)
		else:
			GB_taskTimer = wx.CallLater(_delay, self._reportTableElement, "cell", whichOne, moveToFirst,withFirst)

	script_moveToEndOfColumn.__doc__ = _("Say the last cell of the column. Twice, move to and say it.")
	script_moveToEndOfColumn.category = _scriptCategory
	
	def script_moveToStartOfRow (self, gesture):
		stopScriptTimer()

		whichOne = "firstInRow"
		withFirst = False
		moveToFirst = scriptHandler.getLastScriptRepeatCount() >0
		if withFirst:
			wx.CallAfter(self._reportTableElement, type, whichOne, moveToFirst, withFirst)
		else:
			GB_taskTimer = wx.CallLater(_delay, self._reportTableElement, "cell", whichOne, moveToFirst,withFirst)		

	
	script_moveToStartOfRow.__doc__ = _("Say the first cell of the row. Twice, move to and say it.")
	script_moveToStartOfRow.category = _scriptCategory


	
	def script_moveToEndOfRow (self, gesture):
		stopScriptTimer()
		whichOne = "lastInRow"
		withFirst = False
		moveToFirst = scriptHandler.getLastScriptRepeatCount() >0
		if withFirst:
			wx.CallAfter(self._reportTableElement, type, whichOne, moveToFirst, withFirst)
		else:
			GB_taskTimer = wx.CallLater(_delay, self._reportTableElement, "cell", whichOne, moveToFirst,withFirst)

	script_moveToEndOfRow.__doc__ = _("Say the last cell of the row. Twice, move to and say it.")
	script_moveToEndOfRow.category = _scriptCategory
	

	def script_reportCurrentHeaders(self,gesture):
		if not self.inTable(True):
			return

		cell=self.WinwordSelectionObject.cells[1]
		emptyText = _("Empty")
		rowText=self.fetchAssociatedHeaderCellText(cell,False) 
		if rowText == None:
			rowText = _("No row header")
		elif len(rowText) == 2:
			rowText = _("Row header: %s") %emptyText
		else:
			rowText = _("Row header: %s") %rowText
			
		columnText=self.fetchAssociatedHeaderCellText(cell,True)
		if columnText == None:
			columnText = _("No column header")
		elif len(columnText) == 2 :
			columnText = _("Column header: %s") % emptyText
		else:
			columnText = _("Column header: %s") %columnText
		

		#ui.message("{0} , {1}" .format(rowText ,columnText ))
		ui.message("%s , %s" %(rowText, columnText))
	
	script_reportCurrentHeaders.__doc__ = _("Report currentheaders")
	script_reportCurrentHeaders.category = _scriptCategory

	def fetchAssociatedHeaderCellText(self,cell,columnHeader=False):
		table=cell.range.tables[1]
		rowNumber=cell.rowIndex
		columnNumber=cell.columnIndex
		headerCellTracker=self.getHeaderCellTrackerForTable(table)
		textList = []
		for info in headerCellTracker.iterPossibleHeaderCellInfosFor(rowNumber,columnNumber,columnHeader=columnHeader):
			if columnHeader:
				for headerRowNumber in xrange(info.rowNumber,info.rowNumber+info.rowSpan): 
					try:
						headerCell=table.cell(headerRowNumber,columnNumber)
						text = headerCell.range.text
						textList.append(text) 
					except:
						pass

			else:
				for headerColumnNumber in xrange(info.columnNumber,info.columnNumber+info.colSpan): 

					try:
						headerCell=table.cell(rowNumber,headerColumnNumber)
						text = headerCell.range.text
						textList.append(text)
					except:
						pass


			text=" ".join(textList) if len(textList) else None
			return text
			
		return None
	
	

		

class AppModule(appModuleHandler.AppModule):


	def __init__(self, *args, **kwargs):
		printDebug ("word appmodule init")

		super(AppModule, self).__init__(*args, **kwargs)
		# configuration load
		wordPack.ww_config.load()
		self.hasFocus = False

	
	def chooseNVDAObjectOverlayClasses(self, obj, clsList):
		printDebug ("Word Appmodule ChooseNVDAOverlayClass : %s, %s, clsList:%s" %(obj.role, obj.windowClassName,clsList))
		if obj.windowClassName in ["_WwG"]:
			clsList.insert(0, WordDocumentEx)
			if WordDocument in clsList:

				clsList.remove(WordDocument)
				
	def event_appModule_gainFocus(self):
		printDebug ("Word appModule gainFocus")
		self.hasFocus = True




	def event_appModule_loseFocus(self):
		printDebug ("Word appModule loseFocus")
		self.hasFocus = False


		

	def event_foreground(self, obj, nextHandler):
		if obj.windowClassName in ["_WwG"]:
			maximizeWindow(obj.windowHandle)
		nextHandler()

	def event_NVDAObject_init(self, obj):
		if not self.hasFocus:
			return
		printDebug ("Word Appmodule NVDAObject init: %s, %s" %(obj.role, obj.windowClassName))
		
		

	def event_gainFocus(self, obj, nextHandler):
		printDebug ("Word appModule event_gainFocus: %s, %s" %(obj.role, obj.windowClassName))
		nextHandler()
		

	def script_toggleSkipEmptyParagraphsOption(self, gesture):
		if wordPack.ww_config.toggleSkipEmptyParagraphsOption():
			speech.speakMessage( _("Skip empty paragraphs"))
		else:
			speech.speakMessage(_("Don't skip empty paragraphs"))

	script_toggleSkipEmptyParagraphsOption.__doc__ = _("Toggle on or off the option to skip empty paragraphs")
	script_toggleSkipEmptyParagraphsOption.category = _scriptCategory
	

	def script_toggleDebugFlag(self,gesture):
		if wordPack.ww_utils .toggleDebugFlag():
			speech.speakMessage("debug On")
		else:
			speech.speakMessage("debug off")

	def script_switchPanes(self, gesture):
		from wordPack.ww_funct import sayActivePaneName
		gesture.send()
		oldSpeechMode = speech.speechMode
		speech.speechMode = speech.speechMode_off
		wx.CallLater(200, sayActivePaneName, oldSpeechMode)



	
	def script_testWord(self, gesture):
		print "testWord"
		ui.message("test word")
		obj = api.getFocusObject()
		app = obj.WinwordApplicationObject()
		selection = obj.WinwordSelectionObject
		(start, end) = (obj.WinwordSelectionObject.Start, obj.WinwordSelectionObject.End)
		r = obj.WinwordDocumentObject.range (start, start)
		column = r.information(wdFirstCharacterColumnNumber )
#		column = r.information(9)
		print "col: %s" %column



		
		
	__gestures ={
		"kb:f6": "switchPanes",
		"kb:control+f6": "switchPanes",
		"kb:nvda+alt+f4": "toggleSkipEmptyParagraphsOption",
		"kb:nvda+alt+f9": "toggleDebugFlag",
		"kb:alt+control+f10":"testWord"
	}
