import api
import wx
import ui
from ww_wdConst import wdActiveEndPageNumber , wdFirstCharacterLineNumber , wdGoToEndnote
from ww_collection import Collection, CollectionElement,ReportDialog
import time
from eventHandler import queueEvent
import textInfos
import addonHandler
addonHandler.initTranslation()





class Endnote(CollectionElement):

	def __init__(self, parent, item):
		super(Endnote, self).__init__(parent, item)
		self.start = item.reference.Start
		self.end = item.reference.End
		self.reference = item.Reference
		self.text = ""
		if item.range.text:
			self.text = item.range.text
		r = self.parent.doc.range(self.start, self.start)
		self.line = r.information(wdFirstCharacterLineNumber )
		self.page = r.Information(wdActiveEndPageNumber )

			
	def formatInfos(self):
		sInfo = _("""Page {page}, line {line}
Note's ttext:
{text}
""")

		sInfo = sInfo.replace("\n", "\r\n")
		return sInfo.format(page =self.page, line= self.line, text = self.text)
	def reportText(self):
		pass

class Endnotes(Collection):
	_propertyName = (("Endnotes",Endnote),)
	_name = (_("Endnote"), _("Endnotes"))
	_wdGoToItem = wdGoToEndnote
	def __init__(self, parent,obj, rangeType):
		self.rangeType = rangeType
		self.dialogClass = EndnotesDialog
		self.noElement = _("No endnote")
		super(Endnotes, self).__init__(parent, obj)	
		self.__class__._elementUnit = textInfos.UNIT_CHARACTER
class EndnotesDialog(ReportDialog):

	def __init__(self, parent,obj ):
		super(EndnotesDialog, self).__init__(parent,obj)
		
	def initializeGUI (self):
		self.lcLabel = _("Notes:")
		self.lcColumns = (
			(_("Number"), 100),
			(_("Location"),150),
			)

		lcWidth = 0
		for column in self.lcColumns:
			lcWidth = lcWidth + column[1]
			
		
		self.lcSize = (lcWidth, self._defaultLCWidth)		
		self.buttons = (
			(100, _("&Go to"),self.goTo),
			(101, _("&Delete"), self.delete)
			)


		self.tc1 = {
		"label": _("Note's text"),
		"size": (800,200)
		}
		self.tc2 = None


	def get_lcColumnsDatas(self, element):
		location = _("Page {page}, line {line}") .format(page = element.page, line = element.line)
		index = self.collection.index(element)+1
		datas = (index, location)
		return datas
	def get_tc1Datas(self, element):
		return element.text

