# -*- coding: UTF-8 -*-

import addonHandler
addonHandler.initTranslation()


def onInstall():
	import os
	import shutil
	import globalVars
	import gui
	import wx

	configFile = os.path.join(globalVars.appArgs.configPath, "WordAddon.ini") 
	if os.path.isfile(configFile):
		if gui.messageBox(
			# Translators: the label of a message box dialog.
			_("Do you want to keep current add-on settings ?"),
			# Translators: the title of a message box dialog.
			_("Word add-on installation"),
			wx.YES|wx.NO|wx.ICON_WARNING)==wx.YES:
				try:
					shutil.copy(configFile, os.path.join(os.path.dirname(__file__).decode("mbcs"), "appModules", "wordPack","wordAddon-old.ini"))
				except:
					pass


	
def deleteAddonConfig():
	import os
	import globalVars
	from logHandler import log
	configFile = os.path.join(globalVars.appArgs.configPath, "wordAddon.ini") 
	if not os.path.exists(configFile):
		return
		
	os.remove(configFile )
	if os.path.exists(configFile):
		log.warning("Error on deletion of VLC addon settings file")
		
	
def onUninstall():
	deleteAddonConfig(  )

